/*
  apl-aix.c

  Make table of the APL character set used by Dyadic Systems Dyalog/X on AIX.

  Unicode mappings according to ISO-IEC / JTC 1 / SC 22 N 3067, 1999-12-28.
  Confusion with TACK symbols reflects confusion in the various APL sets as
  to whether the head or the point is the top.
  
  F. da Cruz, Columbia University, July 2000.
*/
struct charinfo {
    unsigned short uc;
    char * name
} info[] = {  
    0x00a0, "NO-BREAK SPACE",
    0x00d7, "MULTIPLY",
    0x2502, "BOX DRAWINGS VERTICAL LINE, RESIDUE",
    0x2524, "BOX DRAWINGS VERTICAL AND LEFT",
    0x00a2, "CENT SIGN",
    0x2510, "BOX DRAWINGS UPPER RIGHT CORNER",
    0x2514, "BOX DRAWINGS LOWER LEFT CORNER",
    0x2534, "BOX DRAWINGS UP AND HORIZONTAL",
    0x252c, "BOX DRAWINGS DOWN AND HORIZONTAL",
    0x251c, "BOX DRAWINGS VERTICAL AND RIGHT",
    0x2500, "BOX DRAWINGS HORIZONTAL",
    0x253c, "BOX DRAWINGS VERTICAL HORIZONTAL INTERSECTION",
    0x2518, "BOX DRAWINGS LOWER RIGHT CORNER",
    0x250c, "BOX DRAWINGS UPPER LEFT CORNER",
    0x2206, "DELTA",
    0x00f7, "DIVIDE SIGN, RECIPROCAL",
    0x2260, "NOT-EQUAL SIGN",
    0x22c4, "DIAMOND",
    0x2375, "OMEGA",			/* 03c9 */
    0x2374, "RHO",			/* 03c1 */
    0x237a, "ALPHA",			/* 03b1 */
    0x220a, "EPSILON",			/* 03b5 */
    0x2261, "MATCH, DEPTH",
    0x2265, "GREATER THAN OR EQUAL SIGN",
    0x2264, "LESS THAN OR EQUAL SIGN",
    0x22a5, "DOWN TACK, DECODE",
    0x22a4, "UP (DOWN) TACK, ENCODE",
    0x2190, "LEFT ARROW",
    0x2218, "JOT",			/* 25e6 */
    0x235d, "UP-SHOE JOT",
    0x233f, "SLASH BAR",
    0x2340, "BACKSLASH BAR",
    0x234e, "DOWN (UP) TACK JOT, EXECUTE",
    0x2355, "UP (DOWN) TACK JOT, FORMAT",
    0x234b, "DELTA STILE",
    0x2352, "DEL STILE",
    0x2372, "UP CARET TILDE",
    0x2371, "DOWN CARET TILDE",
    0x2368, "TILDE DIAERESIS",
    0x235f, "CIRCLE STAR, LOG, NATURAL LOG",
    0x25af, "QUAD",			/* 2395 */
    0x235e, "QUOTE QUAD",
    0x2339, "QUAD DIVIDE",
    0x236b, "DEL TILDE",
    0x236a, "COMMA BAR",
    0x2262, "NOT MATCH, NOT SAME",
    0x230a, "DOWN STILE, MINIMUM, FLOOR",
    0x2308, "UP STILE, MAXIMUM, CEILING",
    0x2349, "CIRCLE BACKSLASH, TRANSPOSE",
    0x2229, "UP SHOE, CAP",		/* 22c2 */
    0x222a, "DOWN SHOE, CUP",		/* 22c3 */
    0x236c, "ZILDE",
    0x00a3, "POUND STERLING",
    0x233d, "CIRCLE STILE, ROTATE, REVERSE",
    0x2296, "CIRCLE BAR",
    0x22a2, "LEFT (RIGHT) TACK",
    0x22a3, "RIGHT (LEFT) TACK",
    0x2337, "SQUISH QUAD",
    0x00af, "OVERBAR",
    0x2373, "IOTA",			/* 03b9 */
    0x00a8, "DIAERESIS",
    0x25cb, "CIRCLE, TRIG FUNCTIONS, PI",
    0x2192, "RIGHT ARROW",
    0x2228, "DOWN CARET, OR",		/* 22c1 */
    0x2282, "LEFT SHOE, PARTITION, ENCLOSE",
    0x2283, "RIGHT SHOE, PICK, DISCLOSE",
    0x2359, "DELTA UNDERBAR",
    0x0041, "CAPITAL APL LETTER A",
    0x0042, "CAPITAL APL LETTER B",
    0x0043, "CAPITAL APL LETTER C",
    0x0044, "CAPITAL APL LETTER D",
    0x0045, "CAPITAL APL LETTER E",
    0x0046, "CAPITAL APL LETTER F",
    0x0047, "CAPITAL APL LETTER G",
    0x0048, "CAPITAL APL LETTER H",
    0x0049, "CAPITAL APL LETTER I",
    0x004a, "CAPITAL APL LETTER J",
    0x004b, "CAPITAL APL LETTER K",
    0x004c, "CAPITAL APL LETTER L",
    0x004d, "CAPITAL APL LETTER M",
    0x004e, "CAPITAL APL LETTER N",
    0x004f, "CAPITAL APL LETTER O",
    0x0050, "CAPITAL APL LETTER P",
    0x0051, "CAPITAL APL LETTER Q",
    0x0052, "CAPITAL APL LETTER R",
    0x0053, "CAPITAL APL LETTER S",
    0x0054, "CAPITAL APL LETTER T",
    0x0055, "CAPITAL APL LETTER U",
    0x0056, "CAPITAL APL LETTER V",
    0x0057, "CAPITAL APL LETTER W",
    0x0058, "CAPITAL APL LETTER X",
    0x0059, "CAPITAL APL LETTER Y",
    0x005a, "CAPITAL APL LETTER Z",
    0x2207, "DEL",
    0x2191, "UP ARROW, TAKE, FIRST",
    0x2193, "DOWN ARROW, DROP",
    0, ""
};

main() {
    int i, j;
    printf("APL-AIX (Dyalog/X)\n");
    printf("char dec col/row oct hex unicod description\n");
    for (i = 160; i < 256; i++) {
	j = i - 160;
	printf("[%c]  %3d  %02d/%02d  %3o  %2X  %04X  %s\n",
	       i, i, i/16, i%16, i, i, (unsigned int)info[j].uc, info[j].name);
    }
}
